package body Windows is

	pragma Ada_05;

	function "not" (X: BOOL) return Boolean is
	begin
		return X = 0;
	end;

	function "+" (X: BOOL) return Boolean is
	begin
		return X /= 0;
	end;

	procedure CloseHandle(Object: HANDLE) is
		Dummy: BOOL;
	begin
		Dummy := CloseHandle(Object);
		pragma Assert(+Dummy);
	end;
	
	procedure FindClose(FindFile: HANDLE) is
		Dummy: BOOL;
	begin
		Dummy := FindClose(FindFile);
		pragma Assert(+Dummy);
	end;

	procedure SetConsoleTitleA(ConsoleTitle: PCASTR) is
		Dummy: BOOL;
	begin
		Dummy := SetConsoleTitleA(ConsoleTitle);
		pragma Assert(+Dummy);
	end;
	
	procedure SetConsoleTitleW(ConsoleTitle: PCWSTR) is
		Dummy: BOOL;
	begin
		Dummy := SetConsoleTitleW(ConsoleTitle);
		pragma Assert(+Dummy);
	end;

	procedure SetConsoleActiveScreenBuffer(ConsoleOutput: HANDLE) is
		Dummy: BOOL;
	begin
		Dummy := SetConsoleActiveScreenBuffer(ConsoleOutput);
		pragma Assert(+Dummy);
	end;

	procedure SetConsoleWindowInfo(ConsoleOutput: HANDLE; Absolute: BOOL; ConsoleWindow: PCSMALL_RECT) is
		Dummy: BOOL;
	begin
		Dummy := SetConsoleWindowInfo(ConsoleOutput, Absolute, ConsoleWindow);
		pragma Assert(+Dummy);
	end;

	procedure SetConsoleScreenBufferSize(ConsoleOutput: HANDLE; Size: COORD_PASS_BY_VALUE) is
		Dummy: BOOL;
	begin
		Dummy := SetConsoleScreenBufferSize(ConsoleOutput, Size);
		pragma Assert(+Dummy);
	end;

	procedure SetConsoleCursorInfo(ConsoleOutput: HANDLE; ConsoleCursorInfo: PCCONSOLE_CURSOR_INFO) is
		Dummy: BOOL;
	begin
		Dummy := SetConsoleCursorInfo(ConsoleOutput, ConsoleCursorInfo);
		pragma Assert(+Dummy);
	end;

	procedure WriteConsoleOutputA(ConsoleOutput: HANDLE; Buffer: PCCHAR_INFO; BufferSize: COORD_PASS_BY_VALUE; BufferCoord: COORD_PASS_BY_VALUE; WriteRegion: PSMALL_RECT) is
		Dummy: BOOL;
	begin
		Dummy := WriteConsoleOutputA(ConsoleOutput, Buffer, BufferSize, BufferCoord, WriteRegion);
		pragma Assert(+Dummy);
	end;
	
	procedure WriteConsoleOutputW(ConsoleOutput: HANDLE; Buffer: PCCHAR_INFO; BufferSize: COORD_PASS_BY_VALUE; BufferCoord: COORD_PASS_BY_VALUE; WriteRegion: PSMALL_RECT) is
		Dummy: BOOL;
	begin
		Dummy := WriteConsoleOutputW(ConsoleOutput, Buffer, BufferSize, BufferCoord, WriteRegion);
		pragma Assert(+Dummy);
	end;

	function CreateWindowA(ClassName: PCASTR; Text: PCASTR; Style: DWORD; X, Y, Width, Height: INT; WndParent: HWND; Menu: HMENU; Instance: HINSTANCE; Param: Pointer) return HWND is
	begin
		return CreateWindowExA(0, ClassName, Text, Style, X, Y, Width, Height, WndParent, Menu, Instance, Param);
	end;
	
	function CreateWindowW(ClassName: PCWSTR; Text: PCWSTR; Style: DWORD; X, Y, Width, Height: INT; WndParent: HWND; Menu: HMENU; Instance: HINSTANCE; Param: Pointer) return HWND is
	begin
		return CreateWindowExW(0, ClassName, Text, Style, X, Y, Width, Height, WndParent, Menu, Instance, Param);
	end;

	procedure ShowWindow(Wnd: HWND; CmdShow: INT) is
		Dummy: BOOL;
	begin
		Dummy := ShowWindow(Wnd, CmdShow);
		pragma Assert(+Dummy);
	end ShowWindow;

	procedure UpdateWindow(Wnd: HWND) is
		Dummy: BOOL;
	begin
		Dummy := UpdateWindow(Wnd);
		pragma Assert(+Dummy);
	end;

	procedure SetFocus(Wnd: HWND) is
		Dummy: HWND;
	begin
		Dummy := SetFocus(Wnd);
	end;

	procedure MoveWindow(Wnd: HWND; X, Y, Width, Height: INT; Repaint: BOOL) is
		Dummy: BOOL;
	begin
		Dummy := MoveWindow(Wnd, X, Y, Width, Height, Repaint);
		pragma Assert(+Dummy);
	end;

	procedure SetWindowTextA(Wnd: HWND; String: PCASTR) is
		Dummy: BOOL;
	begin
		Dummy := SetWindowTextA(Wnd, String);
		pragma Assert(+Dummy);
	end;
	
	procedure SetWindowTextW(Wnd: HWND; String: PCWSTR) is
		Dummy: BOOL;
	begin
		Dummy := SetWindowTextW(Wnd, String);
		pragma Assert(+Dummy);
	end;

	procedure GetClientRect(Wnd: HWND; PRect: access RECT) is
		Dummy: BOOL;
	begin
		Dummy := GetClientRect(Wnd, PRect);
		pragma Assert(+Dummy);
	end;

	procedure SetWindowLongA(Wnd: HWND; Index: INT; NewLong: LONG) is
		Dummy: LONG;
	begin
		Dummy := SetWindowLongA(Wnd, Index, NewLong);
	end SetWindowLongA;

	procedure SetWindowLongW(Wnd: HWND; Index: INT; NewLong: LONG) is
		Dummy: LONG;
	begin
		Dummy := SetWindowLongW(Wnd, Index, NewLong);
	end SetWindowLongW;
	
	function EnumWindowsProc(Window : HWND; Param : LPARAM) return BOOL;
	pragma Convention(stdcall, EnumWindowsProc);
	function EnumWindowsProc(Window : HWND; Param : LPARAM) return BOOL is
		type Callback_Type is access function(Window : HWND) return BOOL;
		function Cast is new Ada.Unchecked_Conversion(LParam, Callback_Type);
	begin
		return Cast(Param).all(Window);
	end EnumWindowsProc;
	
	function Enumerate_Windows return HWND is
		Found : HWND := 0;
		function Callback(Window : HWND) return BOOL is
		begin
			if Each_Window(Window) then
				Found := Window;
				return BOOL_FALSE;
			else
				return BOOL_TRUE; -- continue
			end if;
		end Callback;
		type Callback_Type is access function(Window : HWND) return BOOL;
		pragma Assert(Callback_Type'Size = LPARAM'Size);
		function Cast is new Ada.Unchecked_Conversion(Callback_Type, LPARAM);
		Dummy : BOOL := EnumWindows(EnumWindowsProc'Access, Cast(Callback'Access));
	begin
		return Found;
	end Enumerate_Windows;
	
	procedure PostMessageA(Wnd: HWND; Message: UINT; W: WPARAM; L: LPARAM) is
		Dummy: BOOL;
	begin
		Dummy := PostMessageA(Wnd, Message, W, L);
		pragma Assert(+Dummy);
	end;
	
	procedure PostMessageW(Wnd: HWND; Message: UINT; W: WPARAM; L: LPARAM) is
		Dummy: BOOL;
	begin
		Dummy := PostMessageA(Wnd, Message, W, L);
		pragma Assert(+Dummy);
	end;

	procedure TranslateMessage(Message: access MSG) is
		Dummy: BOOL;
	begin
		Dummy := TranslateMessage(Message);
		pragma Assert(+Dummy);
	end;

	procedure DispatchMessageA(Message: access MSG) is
		Dummy: LRESULT;
	begin
		Dummy := DispatchMessageA(Message);
	end;

	procedure DispatchMessageW(Message: access MSG) is
		Dummy: LRESULT;
	begin
		Dummy := DispatchMessageW(Message);
	end;
	
	procedure DestroyMenu(Menu: HMENU) is
		Dummy: BOOL;
	begin
		Dummy := DestroyMenu(Menu);
		pragma Assert(+Dummy);
	end;

	procedure AppendMenuA(Menu: HMENU; Flags: UINT; IDNewItem: UINT; NewItem: PCASTR) is
		Dummy: BOOL;
	begin
		Dummy := AppendMenuA(Menu, Flags, IDNewItem, NewItem);
		pragma Assert(+Dummy);
	end;

	procedure AppendMenuW(Menu: HMENU; Flags: UINT; IDNewItem: UINT; NewItem: PCWSTR) is
		Dummy: BOOL;
	begin
		Dummy := AppendMenuW(Menu, Flags, IDNewItem, NewItem);
		pragma Assert(+Dummy);
	end;

	procedure SetMenu(Wnd: HWND; Menu: HMENU) is
		Dummy: BOOL;
	begin
		Dummy := SetMenu(Wnd, Menu);
		pragma Assert(+Dummy);
	end;

	procedure MessageBoxA(Wnd: HWND; Text, Caption: PCASTR; uType: UINT) is
		Dummy: INT;
	begin
		Dummy := MessageBoxA(Wnd, Text, Caption, uType);
	end MessageBoxA;

	procedure MessageBoxW(Wnd: HWND; Text, Caption: PCWSTR; uType: UINT) is
		Dummy: INT;
	begin
		Dummy := MessageBoxW(Wnd, Text, Caption, uType);
	end MessageBoxW;

	function Address_Of(S: in String) return PASTR is
		function Cast is new Ada.Unchecked_Conversion(System.Address, PASTR);
	begin
		return Cast(S(S'First)'Address);
	end Address_Of;

	function Address_Of(S: in String) return PCASTR is 
		function Cast is new Ada.Unchecked_Conversion(System.Address, PCASTR);
	begin
		return Cast(S(S'First)'Address);
	end Address_Of;

	function Address_Of(S: in Wide_String) return PWSTR is
		function Cast is new Ada.Unchecked_Conversion(System.Address, PWSTR);
	begin
		return Cast(S(S'First)'Address);
	end Address_Of;

	function Address_Of(S: in Wide_String) return PCWSTR is
		function Cast is new Ada.Unchecked_Conversion(System.Address, PCWSTR);
	begin
		return Cast(S(S'First)'Address);
	end Address_Of;
	
	function To_String(S : not null access constant ACHAR) return String is
		Length: Integer := Integer(lstrlenA(PCASTR(S)));
		Result: String(1..Length);
	begin
		memmove(Result(1)'Address, S.all'Address, Interfaces.C.size_t(Length));
		return Result;
	end To_String;
	
	function To_String(S : not null access constant WCHAR) return Wide_String is
		Length: Integer := Integer(lstrlenW(PCWSTR(S)));
		Result: Wide_String(1..Length);
	begin
		memmove(Result(1)'Address, S.all'Address, Interfaces.C.size_t(Length * 2));
		return Result;
	end To_String;
	
	procedure Assign(D : out ASTR; S : in String) is
		use type Interfaces.C.size_t;
	begin
		pragma Assert(D'Length > S'Length);
		D(D'First + S'Length) := ANULL;
		memmove(D(D'First)'Address, S(S'First)'Address, Interfaces.C.size_t(S'Length));
	end Assign;
	
	procedure Assign(D : out WSTR; S : in Wide_String) is
		use type Interfaces.C.size_t;
	begin
		pragma Assert(D'Length > S'Length);
		D(D'First + S'Length) := WNULL;
		memmove(D(D'First)'Address, S(S'First)'Address, Interfaces.C.size_t(S'Length * 2));
	end Assign;
	
	function Error_Message(Code : DWORD) return String is
		Buffer : Interfaces.C.char_array(0..255);
		Length : DWORD;
	begin
		Length := FormatMessage(
			Flags      => FORMAT_MESSAGE_FROM_SYSTEM or FORMAT_MESSAGE_IGNORE_INSERTS or FORMAT_MESSAGE_ARGUMENT_ARRAY,
			Source     => System.Null_Address,
			MessageId  => Code,
			LanguageId => 0,
			Buffer     => Buffer(Buffer'First)'Access,
			Size       => Buffer'Length,
			Arguments  => System.Null_Address);
		while Length > 0 loop
			case Buffer(Interfaces.C.size_t(Length - 1)) is
			when Interfaces.C.char'Val(0)..Interfaces.C.char'Val(32) | '.' =>
				exit;
			when others =>
				Length := Length - 1;
			end case;
		end loop;
		return To_String(PCTCHAR'(Buffer(Buffer'First)'Unchecked_Access));
	end Error_Message;
	
end Windows;
